from lexer.model.token_types import TokenTypes


class Token:

    def __init__(self, token_type: TokenTypes, value: str) -> None:
        self._type: TokenTypes = token_type
        self._value: str = value

    @property
    def type(self) -> TokenTypes:
        return self._type

    @property
    def value(self) -> str:
        return self._value

    @value.setter
    def value(self, value: str):
        self._value = value

    def __repr__(self) -> str:
        return f'Token <Type: {self._type}> <Value: {self._value}>'

    def __str__(self) -> str:
        return f'Token: Type: {self._type}, Value: {self._value}'
